// Code generated by "requestgen -method GET -type FeesRequest -url /v1/metrics/fees/:metric -responseType Response"; DO NOT EDIT.

package glassnodeapi

import (
	"context"
	"encoding/json"
	"fmt"
	"net/url"
	"regexp"
)

func (f *FeesRequest) SetAsset(Asset string) *FeesRequest {
	f.Asset = Asset
	return f
}

func (f *FeesRequest) SetSince(Since int64) *FeesRequest {
	f.Since = Since
	return f
}

func (f *FeesRequest) SetUntil(Until int64) *FeesRequest {
	f.Until = Until
	return f
}

func (f *FeesRequest) SetInterval(Interval Interval) *FeesRequest {
	f.Interval = Interval
	return f
}

func (f *FeesRequest) SetFormat(Format Format) *FeesRequest {
	f.Format = Format
	return f
}

func (f *FeesRequest) SetTimestampFormat(TimestampFormat string) *FeesRequest {
	f.TimestampFormat = TimestampFormat
	return f
}

func (f *FeesRequest) SetMetric(Metric string) *FeesRequest {
	f.Metric = Metric
	return f
}

// GetQueryParameters builds and checks the query parameters and returns url.Values
func (f *FeesRequest) GetQueryParameters() (url.Values, error) {
	var params = map[string]interface{}{}
	// check Asset field -> json key a
	Asset := f.Asset

	// TEMPLATE check-required
	if len(Asset) == 0 {
		return nil, fmt.Errorf("a is required, empty string given")
	}
	// END TEMPLATE check-required

	// assign parameter of Asset
	params["a"] = Asset
	// check Since field -> json key s
	Since := f.Since

	// assign parameter of Since
	params["s"] = Since
	// check Until field -> json key u
	Until := f.Until

	// assign parameter of Until
	params["u"] = Until
	// check Interval field -> json key i
	Interval := f.Interval

	// assign parameter of Interval
	params["i"] = Interval
	// check Format field -> json key f
	Format := f.Format

	// assign parameter of Format
	params["f"] = Format
	// check TimestampFormat field -> json key timestamp_format
	TimestampFormat := f.TimestampFormat

	// assign parameter of TimestampFormat
	params["timestamp_format"] = TimestampFormat

	query := url.Values{}
	for k, v := range params {
		query.Add(k, fmt.Sprintf("%v", v))
	}

	return query, nil
}

// GetParameters builds and checks the parameters and return the result in a map object
func (f *FeesRequest) GetParameters() (map[string]interface{}, error) {
	var params = map[string]interface{}{}

	return params, nil
}

// GetParametersQuery converts the parameters from GetParameters into the url.Values format
func (f *FeesRequest) GetParametersQuery() (url.Values, error) {
	query := url.Values{}

	params, err := f.GetParameters()
	if err != nil {
		return query, err
	}

	for k, v := range params {
		query.Add(k, fmt.Sprintf("%v", v))
	}

	return query, nil
}

// GetParametersJSON converts the parameters from GetParameters into the JSON format
func (f *FeesRequest) GetParametersJSON() ([]byte, error) {
	params, err := f.GetParameters()
	if err != nil {
		return nil, err
	}

	return json.Marshal(params)
}

// GetSlugParameters builds and checks the slug parameters and return the result in a map object
func (f *FeesRequest) GetSlugParameters() (map[string]interface{}, error) {
	var params = map[string]interface{}{}
	// check Metric field -> json key metric
	Metric := f.Metric

	// assign parameter of Metric
	params["metric"] = Metric

	return params, nil
}

func (f *FeesRequest) applySlugsToUrl(url string, slugs map[string]string) string {
	for k, v := range slugs {
		needleRE := regexp.MustCompile(":" + k + "\\b")
		url = needleRE.ReplaceAllString(url, v)
	}

	return url
}

func (f *FeesRequest) GetSlugsMap() (map[string]string, error) {
	slugs := map[string]string{}
	params, err := f.GetSlugParameters()
	if err != nil {
		return slugs, nil
	}

	for k, v := range params {
		slugs[k] = fmt.Sprintf("%v", v)
	}

	return slugs, nil
}

func (f *FeesRequest) Do(ctx context.Context) (Response, error) {

	// no body params
	var params interface{}
	query, err := f.GetQueryParameters()
	if err != nil {
		return nil, err
	}

	apiURL := "/v1/metrics/fees/:metric"
	slugs, err := f.GetSlugsMap()
	if err != nil {
		return nil, err
	}

	apiURL = f.applySlugsToUrl(apiURL, slugs)

	req, err := f.Client.NewAuthenticatedRequest(ctx, "GET", apiURL, query, params)
	if err != nil {
		return nil, err
	}

	response, err := f.Client.SendRequest(req)
	if err != nil {
		return nil, err
	}

	var apiResponse Response
	if err := response.DecodeJSON(&apiResponse); err != nil {
		return nil, err
	}
	return apiResponse, nil
}
